<?php
namespace Controllers;
//! Base controller
class Controller {

	public $db, $f3, $model, $controller, $users, $messages, $logs, $cd;
	//! HTTP route pre-processor
	function beforeroute() {

	}

	//! HTTP route post-processor
	function afterroute() {
		// Render HTML layout
		$model=$this->f3->get('PARAMS.model');
		$script='';
		// если у модели есть свой js, то сформируем строку для его подключения
		if(file_exists('ui/scripts/'.$model.'.js')) {
			$script='<script type="text/javascript" src="/ui/scripts/'.$model.'.js?v='.$this->f3->get('site_version').'"></script>';
		}

		if(!$this->f3->get('AJAX')) { // если страница вызвана не аяксом, то загружаем полностью шаблон
			$this->f3->set('menu', $this->controller->get_main_menu($logs_n));
			echo \Template::instance()->render('layout.htm')."\n\r".$script;
		}
		else { // а если аяксом то пытаемся показать шаблон только нужной части
			if($this->f3->get('page_data.inc'))	{
				echo \Template::instance()->render($this->f3->get('page_data.inc'))."\n\r".$script;
			}
		}
	}

	//! Instantiate class
	public function __construct() {
		$this->f3 = \Base::instance(); // f3
		if(!$this->f3->get('PARAMS.model')) {
			$this->f3->set('PARAMS.model', 'receipts');
		}
		if(!$this->f3->get('PARAMS.method')) {
			$this->f3->set('PARAMS.method', 'sales');
		}
		$this->controller=new \Models\Controller($this->f3); // модель для всех контроллеров
		$this->messages=new \Models\Messages; // модель с ошибками и сообщениями
		$db_name=$this->f3->get('db_name'); // имя базы данных
		$path=$this->f3->get('PATH');

		if(!file_exists('app/api_config.php')) {
			if(file_exists($db_name)) {
				unlink($db_name);
			}
			if($path!='/settings/api') {
				if($this->f3->get('AJAX')) {
					echo"<script>location.reload();</script>";
					exit();
				}
				else {
					$this->f3->reroute('/settings/api');
				}
			}
			return;
		}

		if(!file_exists($db_name)) { // проверяем наличие базы
			if($path!='/') {
				$this->f3->reroute('/');
				return;
			}
			$res=$this->controller->create_database('app/db.sql', $db_name); // при необходимости создаем базу
			if($res['success']) {
				$this->db=$res['db'];
			}
			else {
				$this->f3->set('page_data', $this->messages->message($res['txt'])); // ошибка, если не удалось создать базу
				$this->afterroute();
				exit();
			}
		}
		else {
			$this->db=new \DB\SQL('sqlite:'.$db_name);
		}
		$this->db->exec('PRAGMA journal_mode=WAL;');//многопоточный режим бд
		$this->db->exec('PRAGMA busy_timeout=10000;'); // 10 секунд если на базе эксклюзивная блокировка

		// Объявляем сессии
		//$this->f3->set('JAR.expire', time()+3600);
		$this->f3->set('JAR.httponly', false);
		$this->f3->set('JAR.path', '/');
		$this->f3->set('JAR.domain', '');

		/*
		new \DB\SQL\Session($this->db,'sessions',TRUE,function(){
  			// Suspect session
  			return true;
		});
		*/
		//если это не апи, то стартуем сессию.
		//апи сбивает работу с данными в сессии
		if(strpos(get_class($this), 'Api')===false)
			new \Session();

		$this->logs=new \Models\Logs($this->db, $this->f3); // модель логов
		$this->users=new \Models\Users($this->db, $this->f3); // модель пользователей
		if($path!='/users/autorization' && $path!='/messages/continue' && strpos(get_class($this), 'Api')===false) { // если мы не на странице авторизации, то проверяем авторизацию пользователя
			if(!$this->users->is_login()) {
				if($this->f3->get('AJAX')) {
					echo"<script>location.reload();</script>";
					exit();
				}
				else {
					$this->f3->reroute('/users/autorization'); // если пользователь не авторизован, то переходим на страницу авторизации
				}
			}
		}

		if($path!='/users/autorization' && $path!='/users/logout' && $path!='/api/auto' && $path!='/api/users' && $path!='/messages/continue' && file_exists('app/api_config.php')) {
			$res=$this->controller->access();
			if(!$res['success']) {
				$this->f3->set('page_data', $this->messages->message($res['txt']));
				$this->afterroute();
				exit();
			}
		}

		$this->cd=new \Models\Cd($this->db, $this->f3);
		if($this->f3->get('AJAX')) {
			if($sinch[0]['time_start']>time()-600) {
				$this->f3->set('page_data', $this->messages->message('sync_is_running'));
				$this->afterroute();
				exit();
			}
		}
		else {
			$logs=$this->logs->select_log(array('read=?', 0));
			$logs_n=count($logs);
			$this->f3->set('alert', $logs_n);
			$this->cd->close_txt();
		}
	}

	// Пагинация
	function pagination($lines_all, $page) {
		$lines_of_page=$this->f3->get('lines_of_page');
		$page_count=ceil($lines_all/$lines_of_page);
		$size=3;
		$pages = array();
		for($i=max($page-$size, 1); $i<=$page_count && $i<=$page+$size; $i++) {
			$pages[]=$i;
		}
		if($pages[0]>3) {
			array_unshift($pages, 1, '...');
		}
		elseif($pages[0]==3) {
			array_unshift($pages, 1, 2);
		}
		elseif($pages[0]==2) {
			array_unshift($pages, 1);
		}
		$n=count($pages)-1;
		if($pages[$n]<$page_count-2) {
			$pages[$n+1]='...';
			$pages[$n+2]=$page_count;
		}
		elseif($pages[$n]==$page_count-2) {
			$pages[$n+1]=$page_count-1;
			$pages[$n+2]=$page_count;
		}
		elseif($pages[$n]==$page_count-1) {
			$pages[$n+1]=$page_count;
		}
		$url=$this->f3->get('URI');
		if($this->f3->get('GET.page')) {
			$url=str_replace('page='.$page, 'page=', $url);
		}
		elseif($this->f3->get('GET')) {
				$url.='&page=';
		}
		else {
			$url.='?page=';
		}
		return array(
			'pages'=>$pages,
			'url'=>$url,
			'page_count'=>$page_count
		);
	}
}
